if not lnHandler then lnHandler = {} end

local storageLogLine = 0
local storageDeathLine = 0
local storageStringRefs = {}
local storageMissString = {}
local storageIconTable = {}
local handlerGetIcon, handlerGetStrings, handlerLogFind, handlerFillIcons

local eventID = {
	[GameData.CombatEvent.HIT] = "HIT",
	[GameData.CombatEvent.CRITICAL] = "HIT",
	[GameData.CombatEvent.ABILITY_HIT] = "SPELL",
	[GameData.CombatEvent.ABILITY_CRITICAL] = "SPELL",
	[GameData.CombatEvent.DISRUPT] = "DISRUPT",
	[GameData.CombatEvent.EVADE] = "EVADE",
	[GameData.CombatEvent.IMMUNE] = "IMMUNE",
	[GameData.CombatEvent.PARRY] = "PARRY",
	[GameData.CombatEvent.BLOCK] = "BLOCK",
	[GameData.CombatEvent.ABSORB] = "ABSORB",
}

lnHandler.FontTypes = {
    {"font_clear_tiny", L"Myriad Pro - Tiny"},
    {"font_clear_small_bold", L"Myriad Pro - Small Bold"},
    {"font_clear_small", L"Myriad Pro - Small"},
    {"font_clear_medium_bold",  L"Myriad Pro - Medium Bold"},
    {"font_clear_medium", L"Myriad Pro - Medium"},
    {"font_clear_large_bold", L"Myriad Pro - Large Bold"},
    {"font_clear_large", L"Myriad Pro - Large"},
	{"font_default_text_small", L"Age of Reckoning - Small"},
	{"font_default_text", L"Age of Reckoning - Medium"},
	{"font_default_text_large", L"Age of Reckoning - Large"},
	{"font_default_text_huge", L"Age of Reckoning - Huge"},
}



function handlerGetIcon( abilityID ) -- get icon to the ID and look in array for ones we dont have
---------------------------------------------------------------
--  Uncomment next line to display missing textures in debug --
---------------------------------------------------------------
	if storageIconTable[abilityID] == nil and (GetAbilityData( abilityID).iconNum == 0 or GetAbilityName(abilityID) == L"" ) and abilityID~=0 then d("No texture found for   <" .. abilityID .. "> '" .. WStringToString(GetAbilityName(abilityID)) .. "'") end
---------------------------------------------------------------
	return storageIconTable[abilityID] or GetAbilityData( abilityID ).iconNum
end 






function lnHandler.Init(bar,tooltip)
	lnHandler.bar = bar
	lnHandler.tooltip = tooltip
	
	RegisterEventHandler( SystemData.Events.PLAYER_NEW_ABILITY_LEARNED, "lnHandler.Event_Ability" )
	RegisterEventHandler( SystemData.Events.WORLD_OBJ_COMBAT_EVENT, "lnHandler.Event_Combat" )
	
	RegisterEventHandler(SystemData.Events.WORLD_OBJ_XP_GAINED, "lnHandler.Event_Exp")
	RegisterEventHandler(SystemData.Events.WORLD_OBJ_RENOWN_GAINED, "lnHandler.Event_Renown")
	RegisterEventHandler(SystemData.Events.WORLD_OBJ_INFLUENCE_GAINED, "lnHandler.Event_Inf")
	RegisterEventHandler(SystemData.Events.PLAYER_DEATH, "lnHandler.Event_Death")
	
	RegisterEventHandler(SystemData.Events.PLAYER_PET_UPDATED, "lnHandler.asdf")
	RegisterEventHandler(SystemData.Events.PLAYER_PET_STATE_UPDATED, "lnHandler.asdff")
	
	handlerGetStrings()
	handlerFillIcons()
end 

function lnHandler.asdf(...)
	d("1") d(...)
end
function lnHandler.asdff(...)
	d("2") d(...)
end


function lnHandler.Scroll(_,_,delta)
	if NaturalLog.BasicVars.FlowUp then lnHandler.bar:Scroll(-delta) else lnHandler.bar:Scroll(delta) end
end 

function lnHandler.Mouse()
	lnHandler.tooltip:SetText(lnHandler.bar:GetLog(SystemData.MouseOverWindow.name))
end 
function lnHandler.MouseEnd()
	lnHandler.tooltip:Hide()
end 





function handlerGetStrings() -- Get id's for hardcoded strings we need to use
	lnHandler.RefTable = {}
	storageLogLine = TextLogGetNumEntries("Combat")
	storageDeathLine = TextLogGetNumEntries("Chat")
	
	UnloadStringTable("Hardcoded")
	LoadStringTable("Hardcoded", "data/strings/<LANG>", "hardcoded.txt", "cache/<LANG>", "lnHandler.RefTable" )
	UnloadStringTable("Hardcoded")
	LoadStringTable("Hardcoded", "data/strings/<LANG>", "hardcoded.txt", "cache/<LANG>", "" )
	
	storageStringRefs["TEXT_YOU_GAIN_X_EXP"] = lnHandler.RefTable["TEXT_YOU_GAIN_X_EXP"]
	storageStringRefs["TEXT_YOU_GAIN_X_RENOWN"] = lnHandler.RefTable["TEXT_YOU_GAIN_X_RENOWN"]
	storageStringRefs["TEXT_YOU_GAIN_X_INFL"] = lnHandler.RefTable["TEXT_YOU_GAIN_X_INFL"]
	storageStringRefs["TEXT_LEARN_ABILITY"] = lnHandler.RefTable["TEXT_LEARN_ABILITY"]
	storageMissString["BLOCK"] = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_BLOCKED"], {0} ))
	storageMissString["EVADE"] = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_EVADED"], {0} ))
	storageMissString["PARRY"] = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_PARRIED"], {0} ))
	storageMissString["DISRUPT"] = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_DISRUPTED"], {0} ))
	storageMissString["ABSORB"] = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_DAMAGE_ABSORBED"], {'%d+'} ))
	storageMissString["ABSORB"] = (string.gsub(storageMissString["ABSORB"], "[(]", "\[\\\(\]"))
	storageMissString["ABSORB"] = (string.gsub(storageMissString["ABSORB"], "[)]", "\[\\\)\]"))
	storagePetString = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_YOUR_PET_HITS_X_FOR_Y"], {'(.*)','(.*)',1,'(.*)','(.*)'} ) )
	storagePetString2 = WStringToString(GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_YOUR_PET_HITS_X_FOR_Y"], {'(.*)','(.*)',2,'(.*)','(.*)'} ) )
	storageDeathString = WStringToString( GetFormatStringFromTable( "Hardcoded", lnHandler.RefTable["TEXT_DEATH_SELF_X"], {'.*'} ) )
	
	lnHandler.RefTable = nil
end 

function handlerLogFind(terms) -- Find terms in the combat log
	while storageLogLine < TextLogGetNumEntries("Combat") do
		local line = WStringToString( select( 3, TextLogGetEntry("Combat", storageLogLine ) ) )
		storageLogLine = storageLogLine + 1
		local match = true
		for key,term in pairs(terms) do
			match = match and string.find(line, term) ~= nil
		end
		if match then return(line) end
	end
end 







function lnHandler.Event_Ability(id)
	local newEvent = {}
	newEvent.iconNum = GetAbilityData( id ).iconNum
	newEvent.etype = "ABILITY"
	newEvent.logtext = WStringToString(GetFormatStringFromTable( "Hardcoded", storageStringRefs.TEXT_LEARN_ABILITY, {GetAbilityName(id)}))
	lnHandler.bar:AddEntry(newEvent)
end 
-- global functions for event triggered info
function lnHandler.Event_Exp(id, xp)
	if id == GameData.Player.worldObjNum and xp >= NaturalLog.LogOptions.XP[7] then
	
		local newEvent = {}
		newEvent.iconNum = 52
		newEvent.text = towstring(xp)
		newEvent.etype = "XP" -- must be registered in NaturalLog.LogOptions
		newEvent.logtext = WStringToString(GetFormatStringFromTable( "Hardcoded", storageStringRefs["TEXT_YOU_GAIN_X_EXP"], {xp}))
		newEvent.tw = 16 newEvent.th = 16 -- texture is 16x16
		newEvent.sw = .7 newEvent.sh = .7 -- scale it to 70 %
		lnHandler.bar:AddEntry(newEvent)
	
	end
end
function lnHandler.Event_Renown(id, rp)
	if id == GameData.Player.worldObjNum and rp >= NaturalLog.LogOptions.RP[7] then
		local newEvent = {}
		newEvent.iconNum = 45
		newEvent.text = towstring(rp)
		newEvent.etype = "RP"
		newEvent.logtext = WStringToString(GetFormatStringFromTable( "Hardcoded", storageStringRefs["TEXT_YOU_GAIN_X_RENOWN"], {rp}))
		newEvent.tw = 16 newEvent.th = 16
		newEvent.sw = .7 newEvent.sh = .7
		lnHandler.bar:AddEntry(newEvent)
	end 
end
function lnHandler.Event_Inf(id, inf)
	if id == GameData.Player.worldObjNum and inf >= NaturalLog.LogOptions.INF[7] then
		local newEvent = {}
		newEvent.iconNum = 111
		newEvent.text = towstring(inf)
		newEvent.etype = "INF"
		newEvent.logtext = WStringToString(GetFormatStringFromTable( "Hardcoded", storageStringRefs["TEXT_YOU_GAIN_X_INFL"], {inf}))
		newEvent.tx = -1 newEvent.ty = 0
		newEvent.tw = 17 newEvent.th = 17
		newEvent.sw = .6 newEvent.sh = .6
		lnHandler.bar:AddEntry(newEvent)
	end 
end
function lnHandler.Event_Death()
	local tempDeathLine = storageDeathLine
	while tempDeathLine < TextLogGetNumEntries("Chat") do
		local line = WStringToString( select( 3, TextLogGetEntry("Chat", tempDeathLine ) ) )
		tempDeathLine = tempDeathLine + 1
		local match = string.find(line, storageDeathString) ~= nil
		if match then 
		
			local newEvent = {}
			newEvent.iconNum = 106
			newEvent.etype = "DEATH"
			newEvent.logtext = line
			newEvent.tw = 16 newEvent.th = 16
			newEvent.sw = .7 newEvent.sh = .7
			lnHandler.bar:AddEntry(newEvent)
			
			tempDeathLine = tempDeathLine + 1 -- account for double pop of the names
			storageDeathLine = tempDeathLine -- it was real death so move line counter
			return
		end
	end
end 
function lnHandler.Event_Combat(objectID, amount, combatEvent, abilityID)
	
	if objectID == 0 then return end
	
	local event, logText
	local crit = combatEvent == GameData.CombatEvent.CRITICAL or combatEvent == GameData.CombatEvent.ABILITY_CRITICAL
	local player = objectID == GameData.Player.worldObjNum or objectID == GameData.Player.Pet.objNum
	
	local tail = ""
	if not player then tail = "OUT" end
	if crit then tail = tail.."_CRIT" end
	
	
	entry = {}
	
	-- If damage or heal
	if crit or combatEvent == GameData.CombatEvent.HIT or combatEvent == GameData.CombatEvent.ABILITY_HIT then
		if amount > 0 then -- heal
			event = "HEAL"..tail
			if (amount < NaturalLog.LogOptions[event][7]) then return end
			entry["iconNum"] = handlerGetIcon( abilityID )
		else -- damage spell
			amount = -amount
			event = eventID[combatEvent]..tail
			if (amount < NaturalLog.LogOptions[event][7]) then return end
			entry["iconNum"] = handlerGetIcon( abilityID )
		end
		
		if GetAbilityName( abilityID ) ~= L"" then 
			logText = handlerLogFind({WStringToString((GetAbilityName( abilityID ):match(L"([^^]+)^?([^^]*)"))), amount})
		else
			logText = handlerLogFind({amount})
			if event == "HITOUT" or event == "HITOUT_CRIT" then 
				if logText:match(storagePetString) or logText:match(storagePetString2) then
					entry["iconNum"] = 154 entry.tw=16 entry.th=16 entry.sw=.75 entry.sh=.75 
				else
					entry["iconNum"] = handlerGetIcon( 2490 ) 
				end
			end
			
		end
		
	-- If miss based event
	else
		if not player and combatEvent == GameData.CombatEvent.ABSORB and amount == 0 then return end
		event = eventID[combatEvent]
		logText = handlerLogFind( {storageMissString[event]} )
		event = event..tail
		amount = nil
		entry["iconNum"] = handlerGetIcon( abilityID )
	end
	

	--send the event to our handler
	entry["text"] = towstring(amount)
	entry["etype"] = event
	entry["logtext"] = logText
	lnHandler.bar:AddEntry(entry)
end 




function handlerFillIcons()
	storageIconTable = {
	-- Main ability values
[1]=2626,[2]=2601,[3]=2602,[5]=2604,[240]=5313,[245]=5004,[260]=22657,[360]=4506,[361]=4477,[362]=4650,[363]=4569,[364]=4455,[365]=4618,[366]=5273,[367]=5274,[368]=5277,[369]=5278,[370]=5281,[371]=5282,[386]=2605,[387]=2607,[388]=2606,[389]=2609,[390]=2627,[391]=2628,[392]=2610,[420]=4506,[421]=4477,[422]=4650,[423]=4569,[424]=4455,[425]=4618,[426]=13448,[427]=13449,[428]=13450,[429]=13451,[430]=13452,[431]=13453,[432]=13454,[433]=13455,[434]=13456,[435]=2605,[436]=2610,[437]=2628,[438]=2607,[439]=2606,[440]=2609,[442]=2522,[443]=5273,[444]=5274,[445]=5277,[446]=5278,[447]=5281,[448]=5282,[500]=22701,[503]=22702,[504]=22709,[505]=22694,[521]=22701,[523]=22704,[526]=22694,[528]=22702,[542]=22697,[544]=22694,[549]=22698,[550]=22709,[563]=22695,[567]=22708,[568]=22704,[569]=22694,[585]=22703,[588]=22709,[589]=22694,[592]=22706,[606]=23172,[607]=23176,[608]=23174,[610]=23173,[611]=23177,[613]=23175,[627]=23161,[628]=23158,[629]=23156,[630]=23159,[631]=23157,[633]=23160,[648]=23165,[649]=23166,[650]=23163,[651]=23164,[652]=23162,[653]=23153,[669]=23170,[670]=23167,[671]=23169,[672]=23171,[673]=23168,[674]=23153,[690]=23155,[692]=23154,[694]=23151,[695]=23153,[696]=23152,[697]=23150,[713]=22711,[714]=22711,[716]=22711,[734]=22707,[735]=22707,[739]=22707,[756]=22707,[758]=22707,[760]=22707,[776]=22710,[777]=22710,[779]=22710,[797]=22714,[798]=22714,[800]=22714,[818]=22705,[819]=22705,[823]=22705,[839]=22712,[840]=22712,[841]=22712,[842]=22657,[1352]=4575,[1353]=4576,[1354]=4577,[1355]=2414,[1356]=4578,[1357]=4579,[1358]=4409,[1359]=4479,[1360]=4580,[1361]=4581,[1362]=4582,[1363]=4515,[1364]=4583,[1365]=4584,[1366]=4585,[1367]=4405,[1368]=4586,[1369]=4587,[1370]=4588,[1371]=4589,[1372]=4517,[1373]=4462,[1374]=2497,[1377]=4101,[1378]=4421,[1380]=4590,[1381]=4591,[1382]=4592,[1383]=4516,[1384]=4593,[1385]=4594,[1386]=4595,[1387]=4596,[1388]=4432,[1392]=22694,[1393]=22709,[1394]=22701,[1395]=22702,[1396]=22702,[1397]=22702,[1398]=22694,[1399]=22704,[1403]=22694,[1404]=22702,[1405]=22702,[1406]=22701,[1407]=22704,[1408]=22702,[1409]=22704,[1410]=22694,[1411]=22701,[1418]=4597,[1419]=4598,[1420]=4599,[1424]=4600,[1425]=4553,[1426]=4601,[1508]=4460,[1509]=4466,[1510]=4477,[1511]=4602,[1512]=4603,[1513]=4656,[1514]=4604,[1515]=4457,[1516]=4605,[1517]=4606,[1518]=4607,[1519]=4566,[1520]=4608,[1521]=4609,[1522]=4610,[1523]=4468,[1524]=4611,[1525]=4612,[1526]=4613,[1527]=4620,[1528]=4527,[1529]=4649,[1530]=4651,[1531]=4616,[1532]=4652,[1536]=4614,[1537]=4653,[1538]=4615,[1539]=4476,[1540]=4531,[1541]=4657,[1542]=4654,[1543]=4655,[1544]=4568,[1548]=22694,[1549]=22708,[1550]=22697,[1551]=22698,[1552]=22704,[1553]=22694,[1554]=22697,[1555]=22709,[1559]=22704,[1560]=22697,[1561]=22708,[1562]=22706,[1563]=22694,[1564]=22697,[1565]=22709,[1566]=22697,[1567]=22698,[1574]=4619,[1575]=4620,[1576]=4621,[1580]=4622,[1581]=4456,[1582]=4623,[1586]=4624,[1587]=4625,[1588]=4626,[1589]=4627,[1590]=4561,[1591]=4562,[1592]=4628,[1593]=4629,[1594]=4630,[1595]=4631,[1596]=4563,[1597]=4632,[1598]=4633,[1599]=4503,[1600]=4634,[1601]=4635,[1602]=4507,[1603]=4558,[1604]=4489,[1605]=4564,[1606]=4636,[1607]=4533,[1608]=4554,[1611]=4559,[1612]=4637,[1613]=4638,[1614]=4639,[1615]=4640,[1616]=4500,[1617]=4641,[1618]=4502,[1619]=4557,[1622]=22702,[1623]=22706,[1624]=22704,[1625]=22694,[1626]=22694,[1627]=22706,[1628]=22703,[1629]=22696,[1632]=22709,[1633]=22702,[1634]=22703,[1635]=22694,[1636]=22704,[1637]=22708,[1638]=22709,[1639]=22706,[1640]=22694,[1643]=4537,[1644]=4642,[1645]=4535,[1648]=4643,[1649]=4644,[1650]=4645,[1655]=4646,[1656]=4647,[1657]=4648,[1664]=2497,[1665]=2551,[1666]=2552,[1667]=2553,[1668]=2554,[1669]=2555,[1670]=2526,[1671]=2556,[1672]=2557,[1673]=2400,[1674]=2558,[1675]=2559,[1676]=2560,[1677]=2499,[1678]=2561,[1679]=2422,[1680]=2562,[1681]=2563,[1682]=2419,[1683]=2457,[1684]=2529,[1685]=2428,[1687]=2527,[1688]=2528,[1689]=2564,[1690]=2565,[1691]=2566,[1692]=2567,[1693]=2568,[1694]=2401,[1695]=2569,[1700]=22704,[1701]=22696,[1702]=22708,[1703]=22694,[1704]=22702,[1705]=22702,[1706]=22701,[1707]=22702,[1711]=22702,[1712]=22707,[1713]=22694,[1714]=22702,[1715]=22704,[1716]=22708,[1717]=22706,[1718]=22701,[1719]=22702,[1721]=2570,[1722]=2453,[1723]=2571,[1727]=2572,[1728]=2573,[1729]=2574,[1733]=2497,[1740]=2441,[1820]=2540,[1821]=2538,[1822]=2625,[1823]=2613,[1824]=2478,[1825]=2617,[1826]=2593,[1827]=2477,[1828]=2484,[1829]=2591,[1830]=2599,[1831]=2592,[1832]=2594,[1833]=2590,[1834]=4529,[1835]=2596,[1836]=2597,[1837]=2598,[1838]=2615,[1839]=2595,[1840]=2489,[1841]=2475,[1842]=2488,[1843]=2507,[1844]=2483,[1846]=2612,[1847]=2589,[1848]=2614,[1849]=2629,[1850]=2608,[1851]=2508,[1852]=2618,[1853]=2619,[1854]=2620,[1856]=22708,[1857]=22702,[1858]=22697,[1859]=22702,[1860]=22697,[1861]=22697,[1862]=22694,[1863]=22709,[1867]=22704,[1868]=22706,[1869]=22697,[1870]=22708,[1871]=22701,[1872]=22701,[1873]=22697,[1874]=22694,[1875]=22709,[1877]=2482,[1878]=4506,[1879]=2621,[1883]=2622,[1884]=2623,[1885]=2624,[1898]=2444,[1899]=2459,[1900]=2575,[1901]=2576,[1902]=2425,[1903]=2577,[1904]=2466,[1905]=2578,[1906]=2579,[1907]=2467,[1908]=2433,[1909]=2580,[1910]=2472,[1911]=2581,[1912]=2582,[1913]=2498,[1914]=2583,[1915]=2584,[1916]=2585,[1917]=2460,[1918]=2477,[1926]=2501,[1927]=4543,[1928]=2463,[1929]=2456,[1930]=2464,[1931]=2403,[1932]=2534,[1933]=2500,[1934]=2504,[1938]=22707,[1939]=22707,[1940]=22708,[1941]=22703,[1942]=22704,[1943]=22694,[1944]=22704,[1945]=22706,[1949]=22703,[1950]=22708,[1951]=22706,[1952]=22695,[1953]=22704,[1954]=22696,[1955]=22694,[1956]=22708,[1957]=22703,[1964]=2505,[1965]=2462,[1966]=2506,[1970]=2586,[1971]=2545,[1972]=2588,[3611]=5140,[3612]=5136,[3613]=5137,[8002]=7990,[8003]=7992,[8004]=7995,[8005]=8068,[8006]=8075,[8007]=8006,[8008]=8002,[8009]=7999,[8010]=7994,[8011]=8009,[8012]=7945,[8013]=8004,[8014]=7997,[8015]=7991,[8016]=8067,[8017]=7961,[8018]=8072,[8019]=8062,[8020]=8003,[8021]=8058,[8022]=7996,[8023]=8010,[8024]=8005,[8025]=8070,[8026]=8057,[8030]=8076,[8031]=8063,[8032]=8074,[8033]=8007,[8034]=8078,[8035]=8071,[8036]=8066,[8037]=8077,[8038]=8061,[8042]=22702,[8043]=22708,[8044]=22701,[8045]=22709,[8046]=22704,[8047]=22703,[8048]=22715,[8049]=22698,[8053]=22694,[8054]=22701,[8055]=22709,[8056]=22706,[8057]=22704,[8058]=22713,[8059]=22702,[8060]=22706,[8061]=22715,[8068]=8060,[8069]=8064,[8070]=8011,[8074]=8065,[8075]=8059,[8076]=8073,[8080]=7966,[8081]=7965,[8082]=8051,[8083]=8052,[8084]=8045,[8085]=7975,[8086]=7976,[8087]=7967,[8088]=7968,[8089]=7974,[8090]=7985,[8091]=7971,[8092]=7972,[8093]=8046,[8094]=7981,[8095]=8011,[8096]=7969,[8097]=8053,[8098]=7983,[8099]=7970,[8100]=7979,[8101]=2497,[8108]=7973,[8109]=8050,[8110]=8047,[8111]=7978,[8112]=7977,[8113]=7982,[8114]=8048,[8115]=7984,[8116]=8049,[8120]=22708,[8121]=22710,[8122]=22702,[8123]=22694,[8124]=22706,[8125]=22703,[8126]=22696,[8127]=22709,[8131]=22701,[8132]=22706,[8133]=22694,[8134]=22701,[8135]=22694,[8136]=22704,[8137]=22709,[8138]=22708,[8139]=22704,[8146]=7988,[8147]=7987,[8148]=7986,[8152]=7980,[8153]=7978,[8154]=7989,[8158]=7913,[8159]=7933,[8160]=7955,[8161]=7911,[8162]=8013,[8163]=8014,[8164]=7910,[8165]=8015,[8166]=7934,[8167]=8016,[8168]=7924,[8169]=8017,[8170]=7902,[8171]=8018,[8172]=8012,[8173]=8019,[8174]=8020,[8175]=7957,[8176]=7940,[8177]=7939,[8179]=4630,[8181]=7919,[8182]=7936,[8183]=8021,[8184]=8022,[8185]=8023,[8186]=8024,[8187]=7958,[8188]=7956,[8189]=7936,[8194]=22708,[8195]=22703,[8196]=22694,[8197]=22713,[8198]=22709,[8199]=22704,[8200]=22703,[8201]=22704,[8204]=22708,[8205]=22706,[8206]=22703,[8207]=22694,[8208]=22704,[8209]=22704,[8210]=22696,[8211]=22703,[8212]=22709,[8215]=8026,[8216]=8027,[8217]=8028,[8220]=7937,[8221]=7941,[8222]=7942,[8236]=8029,[8237]=8030,[8238]=7903,[8239]=7945,[8240]=7959,[8241]=7960,[8242]=7917,[8243]=7950,[8244]=8031,[8245]=8054,[8246]=8032,[8247]=7946,[8248]=7901,[8249]=7943,[8250]=7923,[8251]=8041,[8252]=7953,[8253]=7944,[8254]=8033,[8255]=7927,[8256]=8037,[8257]=8001,[8264]=7904,[8265]=8035,[8266]=8036,[8267]=8034,[8268]=8038,[8269]=8039,[8270]=8040,[8271]=7947,[8272]=7962,[8276]=22708,[8277]=22710,[8278]=22702,[8279]=22706,[8280]=22702,[8281]=22694,[8282]=22710,[8283]=22704,[8287]=22708,[8288]=22694,[8289]=22704,[8290]=22706,[8291]=22703,[8292]=22703,[8293]=22701,[8294]=22696,[8295]=22709,[8302]=7949,[8303]=7905,[8304]=7916,[8308]=8042,[8309]=8043,[8310]=8044,[8314]=5251,[8315]=5168,[8316]=5167,[8317]=5175,[8318]=5179,[8319]=5252,[8320]=5254,[8321]=5253,[8322]=5169,[8323]=5173,[8324]=5184,[8325]=5172,[8326]=5143,[8327]=5181,[8328]=5255,[8329]=5256,[8330]=5176,[8331]=5266,[8332]=5178,[8333]=5257,[8334]=5212,[8335]=5183,[8336]=5182,[8337]=5174,[8338]=5217,[8339]=2497,[8342]=5263,[8343]=5264,[8344]=5186,[8345]=5265,[8346]=5177,[8347]=5259,[8348]=5258,[8349]=5181,[8350]=5269,[8352]=22708,[8353]=22702,[8354]=22694,[8355]=22709,[8356]=22708,[8357]=22702,[8358]=22704,[8359]=22702,[8361]=22708,[8362]=22701,[8363]=22701,[8364]=22694,[8365]=22702,[8366]=22709,[8367]=22706,[8368]=22704,[8369]=22706,[8371]=5210,[8372]=5213,[8373]=5211,[8377]=5260,[8378]=5261,[8379]=5262,[8392]=5187,[8393]=5214,[8394]=5189,[8395]=5190,[8396]=5191,[8397]=5192,[8398]=5193,[8399]=5194,[8400]=5209,[8401]=5216,[8402]=5197,[8403]=5198,[8404]=5195,[8405]=5200,[8406]=5201,[8407]=5202,[8408]=5267,[8409]=5199,[8410]=5205,[8411]=5171,[8412]=5220,[8413]=5218,[8414]=5219,[8415]=5215,[8417]=5221,[8418]=5196,[8419]=5222,[8420]=5223,[8421]=5224,[8422]=5225,[8423]=5204,[8424]=5226,[8425]=5227,[8428]=22708,[8429]=22702,[8430]=22694,[8431]=22701,[8432]=22696,[8433]=22694,[8434]=22704,[8435]=22698,[8438]=22701,[8439]=22708,[8440]=22706,[8441]=22701,[8442]=22709,[8443]=22704,[8444]=22702,[8445]=22704,[8446]=22696,[8449]=5206,[8450]=5207,[8451]=5228,[8454]=5229,[8455]=5230,[8456]=5208,[8470]=5106,[8471]=5112,[8472]=5270,[8473]=5271,[8474]=5272,[8475]=5275,[8476]=5276,[8477]=5279,[8478]=5280,[8479]=5283,[8480]=5284,[8481]=5299,[8482]=5286,[8483]=5153,[8484]=5304,[8485]=5305,[8486]=5149,[8487]=5290,[8488]=5307,[8489]=5312,[8490]=5306,[8491]=5308,[8492]=5309,[8494]=5287,[8495]=5293,[8496]=5294,[8497]=5295,[8498]=5296,[8499]=5297,[8500]=5289,[8501]=5285,[8502]=5300,[8506]=22709,[8507]=22704,[8508]=22703,[8509]=22694,[8510]=22708,[8511]=22709,[8512]=22702,[8513]=22706,[8516]=22706,[8517]=22704,[8518]=22704,[8519]=22694,[8520]=22697,[8521]=22708,[8522]=22713,[8523]=22702,[8524]=22709,[8527]=5301,[8528]=5114,[8529]=5102,[8533]=5151,[8534]=5302,[8535]=5303,[8541]=5310,[8542]=5311,[8548]=5144,[8549]=5113,[8550]=5108,[8551]=5140,[8552]=5104,[8553]=5268,[8554]=5235,[8555]=5233,[8556]=5136,[8557]=5162,[8558]=5142,[8559]=5237,[8560]=5105,[8561]=5240,[8562]=5232,[8563]=5158,[8564]=5244,[8565]=5238,[8566]=5103,[8567]=5239,[8568]=5160,[8569]=5154,[8571]=5236,[8572]=5241,[8573]=5242,[8574]=5119,[8575]=5137,[8576]=5243,[8577]=5162,[8578]=5110,[8579]=5149,[8584]=22706,[8585]=22704,[8586]=22709,[8587]=22708,[8588]=22714,[8589]=22706,[8590]=22704,[8591]=22694,[8594]=22703,[8595]=22708,[8596]=22709,[8597]=22697,[8598]=22708,[8599]=22694,[8600]=22704,[8601]=22708,[8602]=22706,[8605]=5118,[8606]=5134,[8607]=5135,[8611]=5245,[8612]=5246,[8613]=5247,[8621]=5116,[8622]=5155,[9002]=13302,[9003]=13379,[9004]=13370,[9005]=13371,[9006]=13301,[9007]=13372,[9008]=13373,[9009]=13374,[9010]=13375,[9011]=13376,[9012]=7991,[9013]=13378,[9014]=13300,[9015]=13379,[9016]=13338,[9017]=13388,[9018]=13381,[9019]=13304,[9020]=13382,[9021]=13305,[9022]=13386,[9023]=13334,[9025]=13303,[9026]=13384,[9027]=13385,[9028]=13383,[9029]=13387,[9030]=13380,[9031]=13389,[9032]=13394,[9033]=13390,[9034]=2497,[9043]=22706,[9044]=22709,[9045]=22702,[9047]=22708,[9049]=22708,[9050]=22705,[9052]=22698,[9053]=22704,[9056]=13391,[9057]=13392,[9058]=13393,[9062]=22709,[9063]=22709,[9064]=22702,[9065]=22704,[9066]=22703,[9067]=22706,[9068]=22701,[9069]=22706,[9070]=22694,[9074]=13395,[9075]=13396,[9076]=13397,[9080]=13398,[9081]=13399,[9082]=13322,[9083]=13400,[9084]=13309,[9085]=13401,[9086]=13402,[9087]=13310,[9088]=13326,[9089]=13403,[9090]=13404,[9091]=13405,[9092]=13321,[9093]=13406,[9094]=13407,[9095]=13408,[9096]=13325,[9097]=13308,[9098]=13319,[9099]=13323,[9100]=13307,[9101]=13314,[9103]=13311,[9104]=13324,[9105]=13313,[9106]=13330,[9107]=13331,[9108]=13409,[9109]=13317,[9110]=13329,[9111]=13337,[9116]=22704,[9117]=22709,[9118]=22708,[9119]=22697,[9120]=22709,[9121]=22694,[9122]=22697,[9123]=22696,[9126]=22698,[9127]=22697,[9128]=22697,[9129]=22708,[9130]=22698,[9131]=22702,[9132]=22697,[9133]=22702,[9134]=22694,[9137]=13334,[9138]=13335,[9139]=13336,[9142]=13337,[9143]=13338,[9144]=13339,[9148]=13302,[9158]=13417,[9159]=13418,[9160]=13419,[9161]=13420,[9162]=13421,[9163]=13422,[9164]=13423,[9165]=13424,[9166]=13425,[9167]=13426,[9168]=13427,[9169]=13428,[9170]=13430,[9171]=13431,[9172]=13432,[9173]=13433,[9174]=13434,[9175]=13435,[9176]=13436,[9177]=13437,[9178]=13438,[9184]=13429,[9186]=13439,[9187]=13440,[9188]=13441,[9189]=13442,[9190]=13443,[9191]=13444,[9192]=13445,[9193]=13446,[9194]=13447,[9198]=22701,[9199]=22703,[9200]=22702,[9201]=22696,[9202]=22709,[9203]=22706,[9204]=22701,[9205]=22705,[9209]=22694,[9210]=22701,[9211]=22708,[9212]=22703,[9213]=22709,[9214]=22702,[9215]=22709,[9216]=22706,[9217]=22694,[9224]=13457,[9225]=13458,[9226]=13459,[9230]=13460,[9231]=13461,[9232]=13462,[9236]=13340,[9237]=13341,[9238]=13342,[9239]=13343,[9240]=13344,[9241]=13345,[9242]=13346,[9244]=13348,[9245]=13349,[9246]=13350,[9247]=13351,[9248]=13352,[9249]=13353,[9250]=13354,[9251]=13355,[9252]=13356,[9253]=13357,[9255]=13359,[9256]=13358,[9257]=13463,[9258]=13347,[9264]=13360,[9265]=13361,[9266]=13362,[9267]=13363,[9268]=13364,[9269]=13365,[9271]=13412,[9272]=13413,[9273]=4422,[9276]=22703,[9277]=22705,[9278]=22706,[9279]=22703,[9280]=22704,[9281]=22708,[9282]=22694,[9283]=22706,[9287]=22706,[9288]=22708,[9289]=22703,[9290]=22704,[9291]=22709,[9292]=22713,[9293]=22706,[9294]=22694,[9295]=22706,[9302]=13366,[9303]=13367,[9304]=13368,[9308]=13414,[9309]=13415,[9310]=13416,[9314]=11007,[9315]=11008,[9316]=11009,[9317]=11010,[9318]=11011,[9319]=11012,[9320]=11013,[9321]=11014,[9322]=11015,[9323]=11016,[9324]=11017,[9325]=11018,[9326]=11019,[9327]=11020,[9328]=11021,[9329]=11022,[9330]=11023,[9331]=11024,[9332]=11025,[9333]=11026,[9334]=11027,[9335]=11028,[9336]=11037,[9337]=11030,[9342]=11031,[9343]=11032,[9344]=11033,[9345]=11034,[9346]=11035,[9347]=11036,[9348]=11029,[9349]=11038,[9350]=11039,[9354]=22694,[9355]=22709,[9356]=22701,[9357]=22702,[9358]=22702,[9359]=22702,[9360]=22694,[9361]=22704,[9365]=22694,[9366]=22702,[9367]=22702,[9368]=22701,[9369]=22704,[9370]=22702,[9371]=22704,[9372]=22694,[9373]=22701,[9380]=11040,[9381]=11041,[9382]=11042,[9386]=11043,[9387]=11044,[9388]=11045,[9392]=10968,[9393]=10969,[9394]=10903,[9395]=10970,[9396]=10905,[9397]=5170,[9398]=10902,[9399]=10904,[9400]=10972,[9401]=10973,[9402]=10974,[9403]=10975,[9404]=10976,[9405]=10977,[9406]=10978,[9407]=11006,[9408]=10979,[9409]=5166,[9410]=10980,[9411]=10981,[9412]=10982,[9413]=2497,[9420]=10901,[9421]=10983,[9422]=10984,[9423]=10985,[9424]=10986,[9425]=10900,[9426]=10987,[9427]=5203,[9428]=10994,[9432]=22712,[9433]=22701,[9434]=22704,[9435]=22708,[9436]=22709,[9437]=22701,[9438]=22708,[9439]=22702,[9443]=22698,[9444]=22694,[9445]=22702,[9446]=22694,[9447]=22701,[9448]=22706,[9449]=22709,[9450]=22708,[9451]=22701,[9458]=10988,[9459]=10963,[9460]=10990,[9464]=10991,[9465]=10992,[9466]=10993,[9470]=10995,[9471]=10996,[9472]=10907,[9473]=11005,[9474]=10998,[9475]=10908,[9476]=10909,[9477]=10910,[9478]=10911,[9479]=10924,[9480]=10913,[9481]=10914,[9482]=10915,[9483]=10916,[9484]=10917,[9485]=10927,[9486]=10919,[9487]=10920,[9488]=10921,[9489]=10922,[9490]=10962,[9498]=10923,[9499]=10912,[9500]=10925,[9501]=10926,[9502]=10918,[9503]=10928,[9504]=10999,[9505]=11000,[9506]=11001,[9510]=22712,[9511]=22708,[9512]=22704,[9513]=22694,[9514]=22708,[9515]=22696,[9516]=22704,[9517]=22709,[9521]=22708,[9522]=22702,[9523]=22706,[9524]=22697,[9525]=22696,[9526]=22694,[9527]=22704,[9528]=22704,[9529]=22704,[9536]=10929,[9537]=10930,[9538]=10931,[9542]=10932,[9543]=10933,[9544]=10934,[9548]=10935,[9549]=10936,[9550]=10937,[9551]=10938,[9552]=10939,[9553]=10940,[9554]=10941,[9555]=10942,[9556]=10944,[9557]=10945,[9558]=10946,[9559]=10947,[9560]=10948,[9561]=10949,[9562]=10961,[9563]=10951,[9564]=10952,[9565]=10953,[9566]=10954,[9567]=10955,[9568]=10934,[9569]=5188,[9573]=10956,[9574]=10957,[9575]=10950,[9576]=10959,[9577]=10960,[9578]=10958,[9579]=11002,[9580]=11003,[9581]=11004,[9584]=22708,[9585]=22706,[9586]=22704,[9587]=22708,[9588]=22702,[9589]=22706,[9590]=22694,[9591]=22706,[9595]=22702,[9596]=22709,[9597]=22708,[9598]=22709,[9599]=22708,[9600]=22706,[9601]=22694,[9602]=22706,[9603]=22712,[9605]=10962,[9606]=10963,[9607]=10989,[9616]=10965,[9617]=10966,[9618]=10967,
	-- Extra values for oddities (lingering rune of mending, etc)
	[3846]=2553, [3466]=22701, [3901]=2590, [3406]=5212, [3438]=8023, [3262]=10947, [3254]=10955, [3737]=11003, [3902]=2612, [3527]=10974, [3600]=22694, [3551]=4503, 
	[3760]=5186, [3534]=5190, [3860]=22697, [3253]=23154, [800]=22714, [3595]=22714, [3914]=13342, [3561]=22704, [3896]=10975, [3598]=11006, [3584]=10984, [1902]=2425, [3404]=5181,
	[3909]=2582,[3553]=7903,[3610]=10982,[3907]=2575, [3940]=5149, [291]=22714, [3934]=10976, [3751]=7944, [3821]=4409, [3950]=13420, [3819]=7902, [3823]=4583, [3258]=13434,
	}	
end 